<template lang="pug">
q-card.overflow-hidden.q-mb-sm.langitem(
  flat,
  bordered,
  :class="{ 'border-primary': isMine(lang), 'light-dimmed': isOthers(lang) || alreadyAttempted(lang) }"
)
  .bg-warning.q-pa-sm.text-white(v-if="lang.notes") {{ lang.notes }}
  .bg-warning.q-pa-sm.text-white(
    v-if="lang.translatedBy && lang.translatedBy.toString() == 'users/' + user.uid"
  ) {{ $t('translated_by_you') }}
  q-card-section(:horizontal="$q.screen.gt.xs", style="min-height: 130px")
    q-card-section.q-pa-sm.col-auto.text-center.relative(style="width: 135px")
      .justify-between.full-height(
        :class="{ column: $q.screen.gt.xs, row: $q.screen.lt.sm }"
      )
        .col-auto
          q-chip(:class="{ 'q-mb-lg': $q.screen.lt.sm }") {{ codeToLang(lang.srcLang) }}
        .col-auto
          .absolute-center
            .text-h5
              slot(name="score") ??
        .col-auto(:class="{ 'q-mt-lg': $q.screen.lt.sm }")
          q-badge(color="negative", v-if="lang.error") {{ lang.error }}
          q-chip {{ codeToLang(lang.targetLang) }}

    q-separator(:vertical="$q.screen.gt.xs")

    q-card-section.q-pa-sm.col(v-if="!lang.type")
      .text-body1(style="white-space: pre-wrap") {{ lang.srcText }}
      .text-center
        q-icon.q-ma-sm(name="south", size="md", color="grey-5")

      q-input.text-body1(
        @input="fieldUpdated",
        :disable="!isMine(lang)",
        filled,
        autogrow,
        :loading="saving",
        v-model="lang.targetText",
        :label="$t('translation')"
      )

    q-card-section.col.relative(v-if="lang.type")
      q-icon.float-left.on-left(size="lg", :name="fabYoutube", color="red")
      .text-body-1 {{ $t('youtube_msg1') }}
      .text-body-1 {{ $t('youtube_msg2') }}
      div(style="height: 46px", v-if="isMine(lang)")
      q-btn.absolute-bottom-right.q-ma-sm(
        outline,
        v-if="isMine(lang)",
        icon="smart_display",
        @click="openYouTube(lang)"
      ) {{ $t('open_youtube_caption_editor') }}

    q-separator(:vertical="$q.screen.gt.xs")
    q-card-actions(:vertical="$q.screen.gt.xs", align="left")
      slot
        q-btn(
          flat,
          round,
          v-if="!isMine(lang) && !isOthers(lang)",
          icon="lock",
          @click="$emit('lock')"
        )
          q-tooltip(v-if="!isMine(lang) && !isOthers(lang)") {{ $t('lock_for_myself') }}
          q-tooltip(v-if="isMine(lang)") {{ $t('locked_for_me') }}
        q-btn(
          v-if="isMine(lang)",
          flat,
          round,
          color="black",
          icon="lock_open",
          @click="$emit('unlock')"
        )
          q-tooltip {{ $t('unlock') }}
        q-btn(
          v-if="isMine(lang)",
          flat,
          round,
          color="warning",
          icon="unpublished",
          @click="$emit('needhelp')"
        )
          q-tooltip {{ $t('need_help') }}
        q-btn(
          v-if="isMine(lang)",
          flat,
          round,
          color="positive",
          icon="check",
          @click="$emit('done')"
        )
          q-tooltip {{ $t('its_done') }}
  .bg-grey-2.q-pa-sm(v-if="lang.description") {{ lang.description }}
</template>

<script>
import Language from "@/mixins/Language";
import { db, FieldValue } from "@/db";
import { openURL, debounce } from "quasar";
import { fabYoutube } from "@quasar/extras/fontawesome-v5";

export default {
  name: "LangItem",
  props: ["lang", "user", "config"],
  mixins: [Language],
  data: () => {
    return {
      saving: false,
    };
  },
  created() {
    this.fabYoutube = fabYoutube;
    this.fieldUpdated = debounce(this.fieldUpdated, 300);
  },
  methods: {
    alreadyAttempted(item) {
      return item.attemptedBy && item.attemptedBy == `users/${this.user.uid}`;
    },
    isMine(item) {
      return item.activeUser && item.activeUser == `users/${this.user.uid}`;
    },
    isOthers(item) {
      return item.activeUser && item.activeUser != `users/${this.user.uid}`;
    },
    async openYouTube(lang) {
      const mediaSnapshot = await db.doc(lang.media).get();
      const youtube = mediaSnapshot.data().youtube;
      openURL(`https://studio.youtube.com/video/${youtube}/translations`);
    },
    async fieldUpdated() {
      this.saving = true;
      await db.collection("langs").doc(this.lang.id).update({
        markedActiveAt: FieldValue.serverTimestamp(),
        targetText: this.lang.targetText,
      });
      this.saving = false;
    },
  },
};
</script>

<style lang="scss">
// @import "@/styles/quasar.variables.scss";

.border-primary {
  border-color: #21ba45 !important;
}

.langitem {
  .q-spinner-mat {
    position: absolute !important;
    right: 5px !important;
    top: 5px !important;
  }
}
</style>
